#include "defin.h"
#include "gyro_acsel.h"
#include "step_motor.h" // Обслуживание шаговых моторов
#include "fromsmart.h" // Обслуживание шаговых моторов

void setup() {
  setup_motor_system();
  motor_off();

  Serial.begin(115200);
  giroscop_setup();
  delay(100);
  Calc_CompensatorZ(2000);
  t0 = micros() - 5000;
  t2 = micros();
  Speed = 0;
  stepcoder_setup();
   motor_off();
}

void loop()
{
  
//    SpeedL = 1000;
//    SpeedR = 1000;
//    SetSpeed();
//    delay(1000);
//    return;
  t_period = 5000;
  //static int i = 0; // для торможения вывода
  unsigned long micros_;
  micros_ = micros();
  if (micros_ < t2) return;//Если период < t2 анализ. прошло 5000 если да, измеряем угловую скорость.
  BT_input();
  //Опрос гироприбора:
  dt = micros() - t0; // Длительность предыдущего периода регулирования.
  t0 += dt; //Точка начала нового периода регулирования.
  double Dt = double(dt) * 0.000001;
  // Нужно поймать угол, рядом с которым угловая скорость колеблется в районе нуля.
  Data_mpu6050();
  //Расчет угла по показаниям акселерометра
  Acsel = (atan2(AcX, AcZ));// * RAD_TO_DEG;
  Acsel_other_side = Acsel_other_side *0.99 + (atan2(AcY, AcZ))*0.01;
  // скорость угловая В радианах - падения
  Gyro = - (float(GyY) - CompensatorY)  * _1_d_131;
  //Комплементарный фильтр
  AcYsum = ONE_ALFA * (AcYsum + Gyro * Dt) + ALFA * Acsel;
  
  t2 = t0 + t_period;
//  static int ddd=0;
//  if(ddd==30)
//  {
//    Serial.println(AcYsum);
//    ddd=0;
//  }
//  ddd++;
  // Обработка падений для робота без возможности самостоятельного вставания.
  if ((fabs(AcYsum) > 0.57)||(fabs(Acsel_other_side)>0.57)) //Это порог в радианах 30 градусов
  {
    XSpeed = 0;
    OldCommandSpeed = 0;
    CommandSpeed = 0;
    Move = 0;
    SpeedL = 0;
    SpeedR = 0;
    OldXSpeedL = SpeedL;
    OldXSpeedR  = SpeedR;
    Speed = 0;
    if(!flag_crash) SetSpeed();
    //motor_off();
    flag_crash = true;
    return;
  }
  if (flag_crash)
  {
    Move = MoveStab;
    flag_crash = false;
  }



  //  XL = counter_stepL; counter_stepL = 0;
  //  XR = counter_stepR; counter_stepR = 0;
  XSpeedL =  SpeedL;// double(XL) / Dt; //Реальная скорость колес L //SpeedL;//
  XSpeedR =  SpeedR;//double(XR) / Dt; //Реальная скорость колес R //SpeedR;//
  XSpeed =  (XSpeedL + XSpeedR) * 0.5; //Реальная скорость колес

  Move += Dt * (XSpeed - OldCommandSpeed); //Это как раз пройденный путь

  //dSpeedL = (XSpeedL - OldXSpeedL) / Dt;
  //dSpeedR = (XSpeedR - OldXSpeedR) / Dt;
  OldXSpeed = XSpeed;
  double DT = CommandSpeed - OldCommandSpeed;
  DT = constrain(DT, -20, 20);
  OldCommandSpeed += DT;
  Speed = (AcYsum) *  8.0 * 800.0 * 20.0 / (2.0 * PI * 40.0) + 20.0  * Gyro * 800.0 / (40.0 * 2.0 * PI) + XSpeed + Move * 0.13 + (XSpeed - OldCommandSpeed) * 0.056; // - dSpeed * 0.002; //
  OldXSpeedL = SpeedL;
  OldXSpeedR  = SpeedR;
  DT = Turn - TurnOld;
  DT = constrain(DT, -20, 20);
  TurnOld += DT;
  SpeedL = Speed + TurnOld;// - dSpeedL * 0.002 + TurnOld;
  SpeedR = Speed - TurnOld;//- dSpeedR * 0.002 - TurnOld;
  Speed = (SpeedL + SpeedR) * 0.5;
  if (fabs(Speed) < 10.0) //Стабильное значение интегрального звена
  {
    MoveStab = MoveStab * 0.99 + 0.01 * Move;
  }

  // OldCommandSpeed = CommandSpeed; //
  //Speed - это число шагов в секунду
  //Нужно именять длительность периода подстраиваясь под шаг, чтобы был сделан хотябы один шаг.
  if (fabs(SpeedL) < 20.0)
  {
    SpeedL = 0;
  }
  else
  {
    SpeedL = constrain(SpeedL, -maxSpeed, maxSpeed);
  }
  if (fabs(SpeedR) < 20.0)
  {
    SpeedR = 0;
  }
  else
  {
    SpeedR = constrain(SpeedR, -maxSpeed, maxSpeed);
  }
  SetSpeed();
}
